if not AucAdvanced then
	return
end

local folder, core = ...
local Debug = core.Debug
local ENABLE = ENABLE
local pairs = pairs
local IsAddOnLoaded = IsAddOnLoaded
local DEFAULT_CHAT_FRAME = DEFAULT_CHAT_FRAME
local LibStub = LibStub

local Auctioneer = core:NewModule("Auctioneer") --, "AceEvent-3.0", "AceHook-3.0"
local L = LibStub("AceLocale-3.0"):GetLocale(folder, true)

local addonName = "Auc-Advanced"

local LSM = LibStub("LibSharedMedia-3.0", true)
if not LSM then
	return
end

Auctioneer.name = L["Auctioneer"]
Auctioneer.desc = L["Auctioneer is a addon to help with the auction house. It can be downloaded from AuctioneerAddon.com, Curse.com or WowInterface.com"]

--~ local regEvents = {
--~ }

function Auctioneer:OnInitialize()
--~ 	Debug("Auctioneer", "OnInitialize", IsAddOnLoaded(addonName))	
	
	self.db = core.db:RegisterNamespace("Auctioneer", {
		profile = {
			enabled = true,
			sound = "ATT alert",
			scanComplete = true,
			searchComplete = false,
		},
	})
	
	if not self.db.profile.enabled then
		self:SetEnabledState(false)
	end
	
	
end

--~ function Auctioneer:OnEnable()
--~ 	Debug("Auctioneer", "OnEnable", IsAddOnLoaded(addonName))	
--~ end

--~ function Auctioneer:HasOptions()
--~ 	return IsAddOnLoaded("Auc-Advanced")
--~ end

function Auctioneer:GetOptions()
	return {
		name = self.name,
		type = "group",
		get = function(info)
			local key = info[#info]
			return self.db.profile[key]
		end,
		set = function(info, v)
			local key = info[#info]
			self.db.profile[key] = v
		end,
		args = {
			Desc = {
				type = "description",
				name = self.desc,
				order = 1,
			},
			enabled = {
				type = "toggle",	order	= 10,
				name	= ENABLE,
				desc	= L["Enables / Disables the module."],
				set = function(info, v)
					self.db.profile.enabled = v 
					if v == true then
						self:Enable()
					else
						self:Disable()
					end
				end,
				
			},
			sound = {
				type = 'select',	 order	= 11,
				dialogControl = 'LSM30_Sound', --Select your widget here
				values = LSM:HashTable('sound'), -- pull in your font list from LSM
				name = L["Sound"],
				desc = L["Sound to play"],
			},
			
			--
			scanComplete = {
				type = "toggle",	order	= 12,
				name	= L["Scan Complete"],
				desc	= L["Toggle when Auctioneer is finshed scanning."],
				
			},
			searchComplete = {
				type = "toggle",	order	= 13,
				name	= L["Search Complete"],
				desc	= L["Toggle when Auctioneer is done searching. (search tab)"],
				
			},
		}
	}
end



---
local libName = core.title
local libType = "Util"

local lib,parent,private = AucAdvanced.NewModule(libType, libName)
if not lib then return end
--~ local print,decode,_,_,replicate,empty,get,set,default,debugPrint,fill = AucAdvanced.GetModuleLocals()

function lib.GetName()
	return libName
end

-- fastscan: scanstart, querysent, scanprogress, blockupdate, listupdate
-- slowscan: scanstart, querysent, scanprogress, listupdate, scanprogress, pagefinshed, listupdate
-- Batch refresh: scanstart, querysent, scanprogress, listupdate, scanprogress, pagefinshed, listupdate, scanprogress, pagefinshed, scanstats, scanprogress, scanfinshed

-- search page: searchbegin, searchcomplete
-- search page after buy: buyqueue, scanstart, querysent, scanprogress, listupdate, buyqueue, scanprogress, buyqueue, buyqueue, scanprogress, listupdate, bigplaced, listupdate, scanprogress, pagefinshed, scanstats, scanprogress, scanprogress, scanfinshed

--Posting item in appriaser: postqueue, inventory, inventory, postqueue, postresult
--batch post: postqueue, inventory, postqueue, postresult, inventory, postqueue, postresult

local scanning = false
local searching = false
function lib.Processor(callbackType, ...)
--~ 	if Auctioneer:IsEnabled() and callbackType == "scanfinish" then
--~ 		core:ToggleGame(Auctioneer.name, LSM:Fetch('sound', Auctioneer.db.profile.sound) )
--~ 	end
	if Auctioneer:IsEnabled() then
		--make sure our module is enabled.
		
		if callbackType == "scanstart" then
			scanning = true
		elseif callbackType == "scanfinish" then
			scanning = false
			if Auctioneer.db.profile.scanComplete == true then
				core:ToggleGame(L["Scan Complete"], LSM:Fetch('sound', Auctioneer.db.profile.sound) )
			end
		elseif callbackType == "searchbegin" then
			searching = true
		elseif callbackType == "searchcomplete" then
			searching = false
			if Auctioneer.db.profile.searchComplete == true then
				core:ToggleGame(L["Search Complete"], LSM:Fetch('sound', Auctioneer.db.profile.sound) )
			end
		end
	end
	
	
	Debug("Processor", callbackType)
end